%% -*- latex -*-
\chapter{Data link layer}
The first part of the communication framework I present here is
the first of the major layers. To describe it in few words, the
responsibility of this layer is the direct communication between
directly attached nodes. Therefore, the name ``Data link layer''
as this is simular to the layer of the same name from the OSI
model (see \cite{computer_networking}). The reason why this kind
of layer is needed is because the system needs the ability to
organize the delivery of messages between the individual modules
in such a fashion that there is a certain guarantee that the
system will be able to deliver the messages timely. Furthermore,
it is also used when modules are being attached or detached
to/from the network.

The data link layer's view of the network is also quite different
than the global view of the network. To this layer a network is
the graph formed by all the attached links to a single node
point. But since a module has two terminal ends, a module is
therefore also forced to have two data link layer
instantiations. This kind of perspective was already shown back
in figure \ref{fig:com_between_modules}.

First, I will now introduce the major parts in this layer,
briefly describing how they interact with each other. Next I
will examine and describe each of these major parts with state
machines, using the formulation previously described.

\section{The major states of the datalink layer}
If we separate the datalink layer into subareas, we can begin to
study how it is operating to achieve its several goals. This is
visualized as the major states in figure
\ref{fig:datalink_majorparts}.

%\noindent

\begin{Figure}[H]
\begin{pspicture}(9,3)
  %\psframe*[linecolor=blueback](0,0)(6,5){}
  \psset{fillcolor=white,linecolor=black,arcangle=-20,linewidth=1pt,arrowsize=4pt 2}
  \rput(0.5,0.5){
    \rput(0,0){\cnode*{0.15}{root}}
    \rput(2,0){\circlenode{A}{\small\bf NC}}
    \rput(5,0){\circlenode{B}{\small\bf Init}}
    \rput(8,0){\circlenode[fillcolor=green]{C}{\small\bf Run}}
    \psset{fillcolor=white,
      linecolor=transistioncolor,
      linewidth=2pt,
      arrowsize=4pt 2}
    \ncarc[arcangle=-60,fillstyle=none]{->}{C}{A}
    \ncput*{$T_5$}
    \ncarc{->}{A}{B}
    \ncput*{$T_1$}
    \ncarc{->}{B}{A}
    \ncput*{$T_2$}
    \ncarc{->}{B}{C}
    \ncput*{$T_3$}
    \ncarc{->}{C}{B}
    \ncput*{$T_4$}
    \ncline{->}{root}{A}
  }
\end{pspicture}
\caption[Major transition states]{Major transition states in the
  data link layer. The green color indicates the state where the
  system considers itself to be running in a normal forwarding
  mode.}
\label{fig:datalink_majorparts}
\end{Figure}

\paragraph{States}
\begin{description}
\item[NC] Not connected, waiting for a connection to occur. Ping
  messages are being sent continuously.
\item[Init] Initializing the communication.
\item[Run] Running, normal communication.
\end{description}
\paragraph{Transitions}
\begin{description}
\item[$T_1$] A reply from an outside module causing the system
  to start initializing.
\item [$T_2$] No messages have been received for a long
  period. The connection is lost.
\item [$T_3$] The initialization is complete and normal
  communication can proceed.
\item [$T_4$] A module has requested the system to enter
  initialization phase. (Most likely because the module has
  emerged on the net)
\item [$T_5$] Same as in 3, there have been no packages received
  for a long time, therefore connection is now considered lost.
\end{description}

\subsection{Description}
As the terminator starts out in a unconnected state, it must
notify the world of its presence. If it was just to sit silently
and listen, and all the other terminators where to do the same,
none would ever learn about each others presence. Therefore the
module keeps sending a ping message every 10th $\tau$.

When a ping is being received, the terminator knows that some
other terminator exists. Therefore it translates in to the
initializing state where the process of initializing a token
network is started. This part is described further in section
\ref{sec:token}.

During the period of connection and initialization, there is no
guarantee that the network is behaving properly and there is
therefore a large chance that the network may be flooded with
collisions. This is handled by the collision backoff algorithm
described in section \ref{sec:collision_back_off}.

As the initialization of the network is complete, the network
enters a running state where communication happens in a token
based fashion. This means that the delivery has a higher level
of reliability in the transfer of data since the possibility of
collision is relatively small. But if a new terminator appears
on the network, it will force the network back into the
initialization phase since the communication needs to handle
this new member.

If the terminator is suddenly removed from the network, there is
no direct indicator that the connection is lost. But as the
system relies on a token based network, the terminator can see
that a token is not being passed around and therefore realize
that it has lost its connection with the network. Therefore it
translates back to the initial state were it tries to reacquire
the connection.









%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Collision back off}\label{sec:collision_back_off}
At the very lowest level we always have to be prepared for
collisions on the network which is a factor that we have to
consider when two modules wants to communicate at the same time.

The network is not geared towards having many people speaking at
the same time. Therefore as long as the modules have no higher
level control of who is sending out messages, there will be
collisions. This means that we have to develop a method to
minimize this communication mess.

A good way to handle collisions, is by using \emph{exponential
  backoff} when a collision occurs. Exponential backoff is
partly described in \cite[section 5.5]{computer_networking}, as
being an algorithm that delays re-transmission of a package in
random intervals of the time to transmit a single package over
the wire. The method is also described by wikipedia
\\(http://en.wikipedia.org/wiki/Exponential\_backoff).

\subsubsection*{Detecting collisions} 
The references all assumes a network type sophisticated enough
to detect the collision directly as it happens. \cite[section
  5.3.3]{computer_networking} describes how the Ethernet
physical layer detects this by sensing the voltage levels
directly as the package is being transmitted. The node that
detects the collision then sends an inhibition signal out on the
wire so that all know that the last transmission was erroneous.

Normally an RS485 network is not coupled so that communication
lines can be read at the same time that data is being
transmitted. But by altering this typical setup so that reading
is enabled all the time, we can read the logic levels as
messages are being transmitted.

A test showed that sending two signals over the wire results in
a merge of the logic high levels. The test has not yet been
completed with a test together with serial (UART) modules, so it
is not clear how this setup module will respond. But it is
expected to trash the bytes which show partition errors.

The resulting data which is read, can per individual byte be
compared to the individual transmitted byte and then hopefully
tell if there is some corruption of the transmission. Therefore
the implementation is not reflecting how the collision may be
detected - it just assumes that an collision has happened.

\subsection{Implementation}\label{sec:datalink_implementation}
%\end{description}
%\paragraph{Translations for figure \ref{fig:backoff}}

%\begin{description}
%  \setlength{\itemsep}{1pt}
%  \setlength{\parskip}{0pt}
%  \setlength{\parsep}{0pt}
Figure \ref{fig:backoff} visualizes the state machine for
backoff algorithm and the accompanied state and translation
descriptions follow in section \ref{sec:backoff_description}.
\paragraph{States and translations}
\begin{description}
\item[obs] Waiting state where we wait and observe the network.
\item[rcv] In progress of receiving a message.
\item[tmo] Waiting for timeout of time frame $\tau$.
\item[trf] Transferring message.
\item[bko] Waiting for random time period. (see description
  below)
\item[$T_1$] Message is starting to come in on the communication
  device.
\item[$T_2$] Message transfer is complete, and there are no
  messages to send.
\item[$T_3$] Request to send message.
\item[$T_4$] Timeout of $\tau$
\item[$T_5$] Message transfer is complete.
\item[$T_6$] Collision.
\item[$T_7$] End random delay - retry to send message.
\end{description}

The send method is a \emph{time slice} mechanism where packages
are sent according to the time it takes a package to transfer
over the wire. But if the transfer (state \textbf{trf}) is
interrupted by a collision, it enters a randomized backoff state
(state \textbf{bko}) that follows a scheme that describes as
follows:
\begin{align*}
T &= \left\{n \cdot \tau|n\in [0..h]\right\}\\
h &= \text{\# of failed send attempts}
\end{align*}

\begin{sidefig}
\begin{pspicture}(4,10)
  % \psframe[linecolor=blueback](0,0)(6.5,5){}
  \psset{fillcolor=white,linecolor=black,arcangle=-16}
  \rput(0,0.5) {
    \rput(0.3,6){\cnode*{0.15}{root}}
    \rput(2,6){\circlenode{A}{\small\bf obs}}
    \rput(2,8){\circlenode{B}{\small\bf rcv}}
    \rput(1.5,4){\circlenode{C}{\small\bf tmo}}
    \rput(2,2){\circlenode[fillcolor=green]{D}{\small\bf trf}}
    \rput(2,0){\circlenode[fillcolor=green]{E}{\small\bf bko}}
    \psset{fillstyle=none,
      linecolor=black,arcangle=-30,nodesep=3pt}
    \ncline[linecolor=transistioncolor,linewidth=2pt]{->}{root}{A}
    \ncarc[linecolor=transistioncolor,linewidth=2pt]{->}{A}{B}
    \ncput*{$T_1$}
    \ncarc[linecolor=transistioncolor,linewidth=2pt]{->}{B}{A}
    \ncput*{$T_2$}
    \ncline[linecolor=transistioncolor,linewidth=2pt]{->}{A}{C}
    \ncput*{$T_3$}
    \ncline[linecolor=transistioncolor,linewidth=2pt]{->}{C}{D}
    \ncput*{$T_4$}
    \ncarc[linecolor=transistioncolor,linewidth=2pt]{->}{D}{A}
    \ncput*{$T_5$}
    \ncarc[linecolor=transistioncolor,linewidth=2pt]{->}{D}{E}
    \ncput*{$T_6$}
    \ncarc[linecolor=transistioncolor,linewidth=2pt]{->}{E}{D}
    \ncput*{$T_7$} 
  }
\end{pspicture}
\caption[package back off algorithm]{State diagram describing
  the package back off algorithm.} \label{fig:backoff}
\end{sidefig}

\subsubsection{Description}\label{sec:backoff_description}
In words, the idea is that the message is sent as soon as the
timer runs out (state \textbf{tmo}). But in the case that a
collision occurs it is delayed a random number of $\tau$
periods. In the beginning the allowed number is limited to
either 0 or 1 ($h$). But as the number of collisions increases,
the number $h$ increases and therefore the span that the
randomizer selects from increases.

\section{Token engine}\label{sec:token}
A token engine is based on the idea that all modules take turns
on talking by sharing a single token that is cycled around
between the different modules. The idea of execution is simple
to understand and therefore it can for instance be seen in
\cite[Section 5.3.3]{computer_networking} that such turn-taking
algorithms is only described with this simple token cycling
method. But establishing a valid token in a network where there
exists no prior initial knowledge of each other, is not
trivial. Therefore many has tried to investigate this topic
which has resulted in quite a large amount of algorithms that
exists to solve this task. A subset of the available algorithms
can be seen in \cite{distributed_algorithms}.

A simple proposal to solve this kind of problem, is called the
\emph{LCR} algorithm which is thoroughly described in
\cite[Section 3.3]{distributed_algorithms}. This algorithm works
in an environment that is very different from the Odin robot
since each node is only able to communicate directly with its
neighbours and therefore it is not applicable in this
situation. But the algorithm also suggest that if all the
participants id's are known, it is a simple matter of letting
the node with the highest id start with the token. From there it
is easy to guess that the next in the ring should be the node
with the next highest id etc\ldots

I have therefore implemented a version that utilizes this
idea. The network is adapted to our kind of local network and as
before, the algorithm is described with the (soon well known)
state diagram.
%\newpage


\subsection{The statemachine}
The state diagram in \ref{fig:token_statemachine} describes the
state machine driving the token ring network. But below follows a
more deep description of the individual messages, states and their
transitions.

\paragraph{messages}
In order to support the state machine, there exists four major
types of messages:
\begin{description}
\item[PING] Message to indicate presence on the network.
\item[ID] Message containing an id for the token engine
\item[ID\_CONFLICT] In case of two or more modules having the
  same id, this message starts a competition in order to
  generate a new id for the token engine.
\item[TOKEN] The actual token message that is passed around.
\end{description}

\begin{Figure}
\setRuled
\global\def\figside{l}
\centering
\begin{pspicture}(12,8)
%  \psframe[linecolor=blueback](0,0)(12,8){}
  \psset{fillcolor=white,linecolor=black,arcangle=-16}
  \rput(0.2,1.1) {
    \rput(0,4.5){\cnode*{0.15}{root}}
    \rput(1,4){\circlenode{NC}{\small\bf nc}}
    \rput(5,5.5){\circlenode{I}{\small\bf init}}
    \rput(5,2.5){\circlenode{W}{\small\bf wait}}
    \rput(2.5,0){\circlenode{C}{\small\bf cnf}}
    \rput(9,4.5){\circlenode[fillcolor=green]{S}{\small\bf slv}}
    \rput(9,0.5){\circlenode[fillcolor=green]{T}{\small\bf tkn}}
    \psset{fillstyle=none,linecolor=black,arcangle=-20,nodesep=1.5pt,linecolor=transistioncolor,linewidth=2pt}
    \ncline{->}{root}{NC}
    \nccircle[angle=165]{->}{NC}{0.5}
    \nbput*{\small \parbox{1.2cm}{\centering $A_0$,\\ $T_{(PING)}$}}

    \ncline{->}{NC}{I}
    \naput*[nrot=:U]{\small \parbox{1.8cm}{$A_1$,\\$R_{(PING)}$ or\\$R_{(PING\_REPLY)}$}}
    
    \ncline{->}{I}{W}
    \ncput*{\small $A_2$, $T_{(ID)}$}

    \ncline{->}{W}{NC}
    \ncput*{\small $A_{11}$}

    \ncarc[arcangle=20]{<-}{C}{W}
    \naput*[nrot=:U]{\small $A_9$, $T_{(ID\_CONF)}$}

    \ncarc[linecolor=transistioncolor,linewidth=2pt]{->}{C}{W}
    \nbput*[nrot=:U]{\small $A_{10}$, $T_{(ID)}$}

    \ncline[linecolor=transistioncolor,linewidth=2pt]{->}{W}{S}
    \ncput*{\small $A_7$}

    \ncline[linecolor=transistioncolor,linewidth=2pt]{->}{W}{T}
    \ncput*{\small $A_3$}

    \nccircle[angleA=220]{->}{T}{0.5}
    \ncput*{\small $A_4$}

    \ncarc{->}{S}{T}
    \nbput*{\small \parbox{1.4cm}{\raggedleft$A_6$,\\$R_{(TOKEN)}$}}

    \ncarc{->}{T}{S}
    \nbput*{\small \parbox{1.1cm}{$A_5$,\\$T_{(TOKEN)}$}} 

    \ncdiag[angleA=90,angleB=90,linearc=0.5,armA=1.55,armB=2.1]{->}{S}{NC}
    \ncput*{\small $A_{12}$}

    \nccircle[angle=280]{->}{S}{0.45}
    \nbput*{\small \parbox{1.1cm}{$A_8$,\\$R_{(TOKEN)}$}}
  }
\end{pspicture}
\caption[Token network state machine]{State diagram describing
the token network machine. The green states reflects the upper
running state where messages are being forwarded between the
nodes.}
\label{fig:token_statemachine}
\end{Figure}

Furthermore there exists two sub types that will be mixed
together with the above major message types:
\begin{description}
\item[DATA] Indicates that the message contains data to be
  transferred to the next layer in the protocol stack.
\item[PING\_REPLY] Ordinary reply message to the PING message so
  the sender module knows that it has been connected.
\end{description}

\paragraph{States}
\begin{desclist}
\item[nc] is the \emph{not connected} state. This state is an
  abstraction of the actions that are described in section
  \ref{sec:collision_back_off}.
\item[init] is the \emph{initial} state. In this state, an id is
  generated and spread out to all the other connected links.
\item[wait] is the \emph{waiting for ids} state. While in this
  state, we wait for all the other nodes to identify themselves
  to us.
\item[cnf] is the \emph{conflicting id} state. When another
  module sends an id that is the same as our id, we must find a
  new id to send out.
\item[slv] is the \emph{slave} state where we are not allowed to
  communicate, but instead listen to the network.
\item[tkn] is the \emph{token} state. We have the token and are
  allowed to talk. We will keep communicating as long as there
  is any messages to send out.
\end{desclist}


\paragraph{Transitions}
\begin{desclist}
\item[$A_0$] Continuously send out a ping message so that if the
  terminator becomes connected to a node, the other members of
  the node will be notified of its presence.

\item[$A_1$] The terminator sees that it is not alone (see
  section \ref{sec:collision_back_off}) and therefore enters the
  \emph{init} state.

\item[$A_2$] The terminator send out the generated id $i \in I$
  and change to the \emph{wait} state.

\item[$A_3$] The terminator have discovered that it has $I_n =
  \max( I)$ and therefore it is now the token holder. It
  therefore immediately change to the \emph{tkn} state.

\item[$A_4$] As long as there is messages in the message queue,
  keep sending messages. Therefore it stays in the \emph{tkn}
  state.

\item[$A_5$] No more messages present in the message queue.
  Relinquish the token to terminator $I_{n-1}$ from the sorted
  sequence $I$ and change to the \emph{slv} state.

\item[$A_6$] The link receives the token from module
  $I_{n+1}$. It now owns the token and changes to \emph{tkn}
  state.

\item[$A_7$] The link has $i < \max(I)$ and therefore is not the
  initial token owner. Therefore it change to the \emph{slv}
  state, where it awaits messages.

\item[$A_8$] The slave keeps receiving messages with tokens
  until its own token appears.

\item[$A_9$] As the link receives another id that is similar to
  its own $id$, it changes to the \emph{cnf} state

\item[$A_{10}$] The link regenerates an id and resend that one to
  the rest of the network and at the same time sends a note to
  the others to drop the former id from their list of known
  ids. Therefore it returns to the \emph{wait} state so that it
  can resume the handling of receiving ids.

\item[$A_{11}$] If no messages has been seen on the network for
  some time, it returns to the \emph{nc} state.

\item[$A_{12}$] If no messages has been seen on the network for
  some time, it returns to the \emph{nc} state.
\end{desclist}

A token based network is based on the general idea that the
individual participants has a token that they rotate around
between them. This guarantees that there will be nobody sending
out messages that will either collide and therefore be halted
for some unknown amount of times due to the amount of resending
that the individual nodes must do. It also benefits from fair
sharing as long as the node is only allowed to send one package
each time it receives the token.

But though the theory is simple, there are some problems that
make such a network problematic. First of, it takes quite many
steps to setup such a network; many pieces of information must
be shared between the participants and the network is therefore
quite dependent on the fact that all participants must be
thoroughly initialized with this information. Secondly tokens
gets lost, this can happen for many reasons: arbitrary
collisions due to the fact a module gets the idea that it must
start sending data (maybe because it begins to exhibit Byzantine
failures\footnote{Byzantine failures means that a processor
  starts to behave completely arbitrary.}); a module may
disappear, so sending the token to that module means sending the
token out in the void; finally the package can be victim of
noise which will cause the receiver to drop the package before
the contents are examined. Thirdly, adding or removing members
is painful since the entire network must be torn down and
reinitialized again.

But yet again, when it runs, it has a very reliable
communication scheme while being fully aware of all the other
neighbors presence and if all need to participate in
communication, it scales well.

\subsection{Method} 
The idea behind token networks when it runs, it only shifts
between two states: \emph{has token} and \emph{passive} (equal
to state \emph{tkn} and \emph{slv} in figure
\ref{fig:token_statemachine}) which is similar to the
description mentioned in the beginning of section
\ref{sec:token}. But before getting into this running scenario,
we must sort out who shall own the token initially and what
shall the order of token passing be. There are several different
ways to obtain this kind of information based of different
network types and a lot of these are described in
\cite{distributed_algorithms}. But common to all these methods
is the fact that they need a unique id in order to run.

But this can be used if we randomly generates an id in each
module. This is then sent out to all the other modules, which
store all ids together with their own id in a sorted
sequence. Then the module that has generated the highest $id$,
owns the initial token. The next that gets the token is the next
highest and so on.

It is very likely that two modules will accidentally generate
the same ID, so when that happens, they both sends out a message
to all the others that they should delete that id while both at
the same time sending out a new id. This of course loops until
all have achieved a unique ID.

It should be mentioned that the closer that the size of the pool
of possible IDs is to the amount of participating modules, the
higher the chance of ID collision. Eventually the algorithm will
cycle forever if the pool is equal to or smaller than the amount
of participating modules.

\subsection{Conclusion}
The proposed solution of the implementation of a token based
network, works in principle. But it is not very efficient at
establishing the network since the process takes a fair amount
of messages to pass around between the different
participants. On the top of this is the problem that while it is
running through this initialization phase, it is often
susceptible to collisions which will cause the time it takes to
deliver a message, to grow rather extensively.

For now i have not seen any good indication on how to reduce
this lengthy operation for this kind of network.
\cite{distributed_algorithms} has proposed many solutions for
simple synchronized networks that have guaranteed 1 to 1 directed
delivery of operations. But many of these proposed nets have a
series of advantages like knowing exactly who is present in the
network, which I do not have.

So instead of reducing this initial time, I have considered a
couple of ideas to avoid returning to this state. The amount of
\emph{known}\footnote{There may of course exist others, but my
  guess is that they will most likely fall in to the category of
  the described reasons} possible current scenarios where the
algorithm may be forced to enter the initialization phase are:
\begin{description}

\item [Module removal] as the modules are being removed, a
  recipient of tokens disappear. This means that when the token
  is being sent to the module, the token is effectively lost.

\item [Module addition] When a new module appears in the graph,
  it has no identity. Therefore it sends out an inhibit command
  so the rest of the graph becomes aware that something in the
  graph has changed and therefore needs be reevaluated.

\item [Package loss] If an external ``force'' acts upon the
  system and therefore causes the package to flip some bits, The
  low level message corruption check that exists at the basis of
  the serial line, plus a cyclic redundancy check placed at a
  slightly higher level in the data link layer. This can in
  principle happen both for the entire graph and for just one
  recipient which means that in some cases the network will
  survive - but also sometimes the token is lost.

\item [Collision] Collision is not very likely to happen as none
  are allowed to send ``out of order'' packages. But it happens
  in the case of a module addition.
\end{description}
I do not say that it is possible to completely avoid the initial
scenario, but it should obviously be attempted to stay in this
state as long as possible.

The first idea I am considering is if it would be possible to
keep the token network while a module was added. My idea is
basically that the only amount of information that the graph
needs to have added, is the new random id of the new module. So
if I could allow for the token cycle to temporarily pause, while
this one module enters its ID into the graph, then a lot of time
could be saved compared to the amount of messages it would
demand to tear down the whole node and rebuild a completely new
token ring.

Removing a module is a little less hazardous since what would
happen is that a module will fail to respond to the reception of
a token. Then the module that delivered the token, will notice
this and then take the next in the cycle. Should it happen that
the token was lost because of a single corrupt package, the
module will loose its place in the graph, which of course is
bad. A proposal would be to let the graph keep memory of the
failed module until it seems to have failed a maximum number of
times.

This ideas of course needs some investigation and is therefore
just mentioned here as new ideas to improve some of the flaws
that exist in the token based state machine.

%% \noindent\begin{pspicture}(\linewidth,6)
%% \psframe*[linecolor=blueback](0,0)(\linewidth,6){}
%% \psset{linecolor=black,nodesep=3pt}
%% \rput(2,5){\psframebox{\rnode{A}{10}}}
%% \rput(2,3){\psframebox{\rnode{B}{20}}}
%% \rput(2,1){\psframebox{\rnode{C}{30}}}
%% \ncline{->}{A}{B}
%% \ncline{->}{B}{C}
%% \ncangles[angleB=180,angleA=180,fillstyle=none]{->}{C}{A}

%% \rput(5,5){\psframebox{\rnode{A}{10}}}
%% \rput(5,3){\psframebox{\rnode{B}{20}}}
%% \rput(5,1){\psframebox{\rnode{C}{30}}}
%% \rput(6,4){\psframebox{\rnode{D}{15}}}
%% \pnode(5,4){DD}

%% \ncline{->}{A}{B}
%% \ncline{->}{B}{C}
%% \ncline{->}{D}{DD}
%% \ncangles[angleB=180,angleA=180,fillstyle=none]{->}{C}{A}

%% \rput(8,5){\psframebox{\rnode{A}{10}}}
%% \rput(8,3){\psframebox{\rnode{B}{20}}}
%% \rput(8,1){\psframebox{\rnode{C}{30}}}
%% \rput(8,4){\psframebox{\rnode{D}{15}}}

%% \ncline{->}{A}{D}
%% \ncline{->}{D}{B}
%% \ncline{->}{B}{C}
%% %\ncline{->}{D}{DD}
%% \ncangles[angleB=180,angleA=180,fillstyle=none]{->}{C}{A}
%% \end{pspicture}

% LocalWords:  backoff
